#include <iostream>
#include <vector>
#include <map>
#include <algorithm>
#include <set>
#include <string>
#include <utility>
#include <queue>
#include <deque>
#include <stack>
#include <numeric>
#include <functional>
#include <cmath>
#include <iomanip>
using namespace std;
typedef long long ll;
typedef double db;
typedef vector<ll> vl;
typedef vector<vl> vvl;
typedef set<ll> sl;
typedef vector<string> vs;
typedef map<ll, ll> ml;
#define fi(i, n) for (ll i = 0; i < n; i++)
#define fie(i, s, f) for (ll i = s; i < f; i++)
#define fd(i, n) for (ll i = n - 1; i >= 0; i--)
#define fde(i, s, f) for (ll i = s; i >= f; i--)
#define sp setprecision
vl p, s;
ll n, m;
ll DSUFind(ll a) {
	if (a == p[a]) return a;
	else return p[a] = DSUFind(p[a]);
}
bool DSUUnion(ll a, ll b) {
	a = DSUFind(a);
	b = DSUFind(b);
	if (s[a] < s[b]) swap(a, b);
	s[a] += s[b];
	p[b] = a;
	if (s[a] == n) return 1;
	else return 0;
}
int main() {
	cin.sync_with_stdio(0);
	cout.sync_with_stdio(0);
	cin.tie();
	cout.tie();
	cin >> n >> m;
	s.resize(n, 1);
	p.resize(n);
	fi(i, n) p[i] = i;
	ll a, b;
	fi(i, m) {
		cin >> a >> b;
		a--; b--;
		if (DSUUnion(a, b)) {
			cout << i + 1;
			return 0;
		}
	}
	cout << "-1";
}