#include <bits/stdc++.h>

using namespace std;

#define ll long long

const ll INF = 1e18;

const int maxN = 100005;

int arr[maxN];

ll dp[maxN];

int main()
{
    //freopen("in.in", "r", stdin);

    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n;
    ll k;
    cin >> n >> k;

    for(int i = 0; i < n; i++) cin >> arr[i];

    sort(arr, arr + n);

    dp[n] = 0;

    for(int l = n-1; l > 0; l--)
    {
        dp[l] = INF;
        for(int r = l; r < n; r++)
        {
            ll cost = (arr[r] - arr[l - 1] + k) * (n - l);

            dp[l] = min(dp[l], dp[r + 1] + cost);
        }
    }
    dp[0] = INF;
    for(int r = 0; r < n; r++)
    {
        ll cost = (arr[r] + k) * n;

        dp[0] = min(dp[0], dp[r + 1] + cost);
    }

    cout << dp[0] << endl;




    return 0;
}
