#include <iostream>
#include <cstdlib>
#include <algorithm>
#include <vector>
#include <deque>
#include <string>

using namespace std;

int nf, mf, n0, m0;
char upper[301][301], lower[301][301];
int hu[301], hl[301];

int count_score(int dx, int dy)
{
	int res = 0;
	for (int i = 0; i < n0; i++)
		for (int j = 0; j < m0; j++)
			if (lower[i][j] == '#' && (j - dx + 1 >= 0 && j - dx + 1 < mf && i - dy >= 0 && i - dy < nf) && upper[i - dy][j - dx + 1] == '*')
				res++;
	return res;
}

int count_down(int displ)
{
	int res = -1;
	for (int i = 0; i < m0; i++)
	{
		if (i - displ < mf && i - displ >= 0 && hl[i] != 0 && hu[i - displ] != 0)
			res = max(res, hl[i] + hu[i - displ]);
	}
	return res;
}

int main(void)
{
	cin >> nf >> mf;
	int res = 0;
	for (int i = 0; i < nf; i++)
		for (int j = 0; j < mf; j++)
		{
			cin >> upper[i][j];
			if (upper[i][j] == '*')
				hu[j] = max(hu[j], i + 1);
		}
	cin >> n0 >> m0;
	for (int i = 0; i < n0; i++)
		for (int j = 0; j < m0; j++)
		{
			cin >> lower[i][j];
			if (lower[i][j] == '#')
				hl[j] = max(hl[j], n0 - i);
		}
	for (int displ = -mf - 2; displ <= mf + 2; displ++)
	{
		int dwn = count_down(displ);
		if (dwn == -1)
			continue;
		dwn = n0 - dwn;
		res = max(res, count_score(displ, dwn));
	}
	cout << res;
	return 0;
}
