#include <cstdio>
#include <cstring>

const int STR_MAX = 5001;

char * FindLast(char *Src, char *SubStr)
{
  char *pr, *sub;
  do
  {
    pr = Src - 1;
    sub = strstr(Src, SubStr);
    Src = sub + 1;
  } while (sub != nullptr);

  return strstr(pr, SubStr);
}

int main(void)
{
  char in[STR_MAX], out[STR_MAX];
  int len;

  //freopen(".in", "r", stdin);
  scanf("%d%s%s", &len, in, out);

  int sub = 0;
  char
    *ssb = in, *sse = out + len,
    s[STR_MAX]{0}, *ssf = nullptr;
  while (ssb + sub <= in + len)
  {
    sub = 1;
    memset(s, 0, STR_MAX);
    do
    {
      strncpy(s, ssb, sub);
      sub++;
      ssf = FindLast(out, s);
    } while (ssf != nullptr);
    sub -= 2;
    memset(s, 0, STR_MAX);
    strncpy(s, ssb, sub);
    ssf = FindLast(out, s);

    if (ssf + sub < sse)
    {
      printf("No\n");
      fclose(stdin);
      return 0;
    }
    else
      sse = ssf, ssb += sub;
  }

  fclose(stdin);
  printf("Yes\n");
  return 0;
}
