#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <fstream>

using namespace std;

vector<vector<int> > g;
vector<bool> used;
vector<int> ans;

bool comp(int i, int j)
{
	return ans[i] < ans[j];
}

int dfs(int v)
{
	if (used[v])
		return ans[v];
	used[v] = 1;
	for (int u : g[v])
	{
		ans[v] = max(ans[v], dfs(u) + 1);
	}
	return ans[v];
}

int main()
{
	//ifstream cin("input.txt");
	int n, m;
	cin >> n >> m;
	vector<pair<int, int> > arr(m);
	g.resize(n);
	used.resize(n);
	ans.resize(n);
	for (auto &i : arr)
	{
		cin >> i.first >> i.second;
		i.first--;
		i.second--;
		g[i.second].push_back(i.first);
	}
	vector<int> s(n);
	for (int i = 0; i < n; i++)
	{
		s[i] = i;
		dfs(i);
    }
	//cerr << "\n";
	sort(s.begin(), s.end(), comp);
	if (ans[s.back()] < n - 1)
	{
		cout << -1;
		return 0;
	}
	set<pair<int, int> > tc;
	for (int i = 0; i < n - 1; i++)
	{
		tc.insert(make_pair(s[i], s[i + 1]));
	}
	int CNT = 0;
	for (auto &p : arr)
	{
		CNT++;
		tc.erase(p);
		if (tc.empty())
		{
			cout << CNT;
			return 0;
		}

	}
	return 0;
}