import java.io.*;
import java.util.*;

public class B {

    private int toInt(char c) {
        if (c == 'U') {
            return 0;
        } else if (c == 'L')
            return 1;
        else if (c == 'D')
            return 2;
        else
            return 3;
    }

    public void solve() throws IOException {
        int n = nextInt();
        Car[] cars = new Car[n];
        int[] ans = new int[n];
        for (int i = 0; i < n; i++) {
            int a = nextInt();
            ans[i] = -1;
            char b = nextToken().charAt(0);
            cars[i] = (new Car(a, toInt(b), i));
        }
        int time = 0;
        int c = 0;
        List<Queue<Integer>> cross = new ArrayList<>(4);
        for (int i = 0; i < 4; i++)
            cross.add(new LinkedList<>());
        while (c < n) {
            while (c < n && cars[c].timeIn == time) {
                cross.get(cars[c].dir).add(cars[c].id);
                c += 1;
            }
            boolean f = true;
            while (f) {
                f = false;
                while (c < n && cars[c].timeIn == time) {
                    cross.get(cars[c].dir).add(cars[c].id);
                    c += 1;
                }
                boolean[] block = new boolean[2];
                for (int j = 0; j < 4; j++) {
                    if (cross.get((j + 1) % 4).isEmpty()) {
                        if ((!(cross.get(j).isEmpty())) && !block[j % 2]) {
                            f = true;
                            int car = cross.get(j).poll();
                            ans[car] = time;
                            block[1 - j % 2] = true;
                        }
                    }
                }
                if (f)
                    time += 1;
            }
            if (c < n)
                time = cars[c].timeIn;
        }
        for (int i = 0; i < n; i++) {
            out.println(ans[i]);
        }
    }

    public void run() {
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new B().run();
    }

}

class Car {
    int timeIn;
    int dir;
    int id;

    public Car(int timeIn, int dir, int id) {
        this.timeIn = timeIn;
        this.dir = dir;
        this.id = id;
    }
}
