import java.util.*;
import java.io.*;

public class B1 {
	
	FastScanner in;
	PrintWriter out;
	
	public void solve() throws IOException {
		int n = in.nextInt();
		
		Queue<Car> U = new LinkedList<Car>();
		Queue<Car> L = new LinkedList<Car>();
		Queue<Car> D = new LinkedList<Car>();
		Queue<Car> R = new LinkedList<Car>();

		int u = 0;
		int l = 0;
		int d = 0;
		int r = 0;
		
		for (int i = 0; i < n; i++){
			int x1 = in.nextInt();
			String x2 = in.next();

			switch (x2){
				case "U":{
					U.add(new Car(x1, i));
					break;
				}
				case "L":{
					L.add(new Car(x1, i));
					break;
				}
				case "D":{
					D.add(new Car(x1, i));
					break;
				}
				case "R":{
					R.add(new Car(x1, i));
					break;
				}
			}
		}
		int time = -1;
		int []ans = new int [n+1];
		boolean dvig = true;
		Arrays.fill(ans, -1);
		while(dvig){
			dvig = false;
			if(u+d+r+l == 0){
				int r1 = Integer.MAX_VALUE;
				int l1 = Integer.MAX_VALUE;
				int u1 = Integer.MAX_VALUE;
				int d1 = Integer.MAX_VALUE;
				if(!R.isEmpty()){
					r1 = R.peek().arr;
				}
				if(!L.isEmpty()){
					l1 = L.peek().arr;
				}
				if(!U.isEmpty()){
					u1 = U.peek().arr;
				}
				if(!D.isEmpty()){
					d1 = D.peek().arr;
				}
				time = Math.min(Math.min(r1, l1),
						        Math.min(u1, d1));
			}
			if((!R.isEmpty())&&(R.peek().arr == time)){
				r++;
			}
			if((!L.isEmpty())&&(L.peek().arr == time)){
				l++;
			}
			if((!U.isEmpty())&&(U.peek().arr == time)){
				u++;
			}
			if((!D.isEmpty())&&(D.peek().arr == time)){
				d++;
			}
			boolean est = false;
			if((u != 0)&&(l == 0)){
				u--;
				ans[U.peek().id] = time+1;
				U.poll();
				est = true;
				dvig = true;
			}
			if((l != 0)&&(d == 0)){
				l--;
				ans[L.peek().id] = time+1;
				L.poll();
				dvig = true;
			}
			if((d != 0)&&(r == 0)){
				d--;
				ans[D.peek().id] = time+1;
				D.poll();
				dvig = true;
			}
			if((r != 0)&&(est == false)&&(u == 0)){
				r--;
				ans[R.peek().id] = time+1;
				R.poll();
				dvig = true;
			}
			time++;
		}
		for(int i = 0;i<n;i++){
			if(ans[i] != -1){
				System.out.println(ans[i]-1);
			} else {
				System.out.println(ans[i]);
			}
		}
	}
	
	public void run() {
		try {
			in = new FastScanner (new BufferedReader(new InputStreamReader(System.in)));
			out = new PrintWriter (new BufferedWriter (new OutputStreamWriter(System.out)));
			
			solve();
			
			out.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
	
	class FastScanner {
		BufferedReader br;
		StringTokenizer st;
		
		FastScanner (BufferedReader bufferedreader) {
			br = new BufferedReader (new InputStreamReader(System.in));
		}
		
		String next() {
			while (st == null ||!st.hasMoreTokens()){
				try {
					st = new StringTokenizer(br.readLine());
				} catch (IOException e) {
					e.printStackTrace();
				}
			}
			return st.nextToken();
		}
		
		int nextInt() {
			return Integer.parseInt(next());
		}
	}
	
	public static void main (String[] args) {
        Locale.setDefault(Locale.US);
        new B1().run();
	}
	
	static class Car {
		int id;
		int arr;
		
		public Car(int arr, int id) {
			this.arr = arr;
			this.id = id;
		}
	}
	
}
