#include <iostream>

using namespace std;

int main()
{
    int n1, m1;
    cin >> n1 >> m1;
    char arr[n1][m1];
    for (int i = 0; i < n1; i++)
    {
        for (int j = 0; j < m1; j++)
        {
            cin >> arr[i][j];
        }
    }
    int len1_[m1];
    for (int i = 0; i < m1; i++)
        len1_[i] = -1e9;
    for (int i = 0; i < n1; i++)
    {
        for (int j = 0; j < m1; j++)
            if (arr[i][j] == '*')
                len1_[j] = max(len1_[j], i + 1);
    }

    int n2, m2;
    cin >> n2 >> m2;
    char q[n2][m2];
    for (int i = 0; i < n2; i++)
    {
        for (int j = 0; j < m2; j++)
        {
            cin >> q[i][j];
        }
    }

    int len2_[m2];
    for (int i = 0; i < m2; i++)
        len2_[i] = -1e9;
    for (int i = 0; i < n2; i++)
    {
        for (int j = 0; j < m2; j++)
            if (q[i][j] == '#')
                len2_[j] = max(len2_[j], n2 - i);
    }

    int res = 0;
    for (int x = -300; x <= 300; x++)
    {
        int h = 0;
        for (int i = 0; i < m1; i++)
        {
            if (i + x >= 0 && i + x < m2)
            {
                h = max(len1_[i] + len2_[i + x], h);
            }
        }
        if (h >= 0)
        {
        char w[h][m2 + 1];
        for (int i = 0; i < h; i++)
        {
            for (int j = 0; j <= m2; j++)
                w[i][j] = '.';
        }

        for (int i = 0; i < n1; i++)
        {
            for (int j = 0; j < m1; j++)
            {
                if (j + x >= 0 && j + x <= m2 && arr[i][j] == '*')
                    w[i][j + x] = '*';
            }
        }
        for (int i = 0; i < n2; i++)
        {
            for (int j = 0; j < m2; j++)
                if (q[i][j] == '#')
                    w[h - (n2 - i)][j] = '#';
        }
        int ans = 0;
        for (int i = 0; i < h; i++)
        {
            for (int j = 0; j < m2; j++)
            {
                if (w[i][j] == '#' && w[i][j + 1] == '*')
                    ans++;
            }
        }
        res = max(res, ans);
        }
    }
    cout << res << endl;
    return 0;
}
