import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.Locale;
import java.util.StringTokenizer;

public class H {
    public void solve() throws IOException {
    	int n = nextInt();
    	long a = 100;
    	int b = 10;
    	for (int i = 0; i < n; i++) {
    		out.println(a);
    		a *= 2;
    		b = tenPow((len(a) + 1) / 2);
    		a = (a + b - 1) / b * b;
    	}
    }

	public int len(long n) {
		return (n + "").length();
	}
	
	public int tenPow(int k) {
		if (k == 0) {
			return 1;
		}
		return 10 * tenPow(k - 1);
	}
    
    public void run() {
        try {
            br = new BufferedReader(new InputStreamReader(System.in)); 
            out = new PrintWriter(System.out);

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new H().run();
    }

}
