#include <iostream>
#include <cstdlib>
#include <algorithm>
#include <vector>
#include <deque>
#include <string>

using namespace std;

const long long m = (long long)(1e9 + 7);

long long cnt_2(long long x)
{
	long long cnt = 0;
	while (x > 0)
		cnt++, x /= 2;
	return cnt;
}

long long pow2(long long x)
{
	int res = 1;
	for (int i = 0; i < x; i++)
		res *= 2;
	return res;
}

int main(void)
{
	long long n;
	cin >> n;
	long long sum = 0;
	long long cnt_2n = cnt_2(n);

	for (long long i = 0; i < cnt_2n; i++)
	{
		long long pw2i = pow2(i);
		long long n0 = (pw2i * ((n + 1) / (pw2i * 2)) + min(pw2i, (n + 1) % (pw2i * 2))) % m;
		long long n1 = (pw2i * ((n + 1) / (pw2i * 2)) + max((long long)0, (n + 1) % (pw2i * 2) - pw2i)) % m;
		sum = (sum + ((n0 * n1) % m * pw2i) % m) % m;
	}

	sum = (sum - (n * (n + 1) / 2) % m + m) % m;

	cout << sum << endl;

	return 0;
}
