#include <bits/stdc++.h>

using namespace std;

const int MAXN = 110000;

int used[MAXN];
vector<int> topsort;
vector<int> g[MAXN];

void dfs(int v) {
    used[v] = 1;
    for (auto i : g[v])
        if (!used[i])
            dfs(i);
    topsort.push_back(v);
}


map<pair<int, int>, int> mp;
int main()
{
//    freopen("input.txt", "r", stdin);
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
//    freopen("output.txt", "w", stdout);
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < m; ++i) {
        int a, b;
        cin >> a >> b;
        g[--a].push_back(--b);
        mp[{a, b}] = i;
    }
    for (int i = 0; i < n; ++i)
        if (!used[i])
            dfs(i);
    reverse(topsort.begin(), topsort.end());
//    cout << topsort.size();
    int ans = 0;
    for (int i = 0; i < topsort.size() - 1; ++i) {
        if (mp.find({topsort[i], topsort[i + 1]}) == mp.end()) {
            cout << -1;
            return 0;
        }
        ans = max(ans, mp[{topsort[i], topsort[i + 1]}] + 1);
    }
    cout << ans;
}
