#include <iostream>
#include <queue>
#include <algorithm>

using namespace std;

queue<pair<long,long>> Up, Down, Left, Right;
vector<pair<long, long>> Output;

int main()
{
    long n;
    cin>>n;

    for(long long i = 0; i < n; ++i){
        long t;
        char direction;
        cin>>t>>direction;
        switch(direction){
            case 'U':
                Up.push(pair<long,long>(t, i));
                break;
            case 'D':
                Down.push(pair<long,long>(t, i));
                break;
            case 'R':
                Right.push(pair<long,long>(t, i));
                break;
            case 'L':
                Left.push(pair<long,long>(t, i));
                break;
        }
    }

    for(long long i = 0; ; ++i){
        int f=0;
        bool l=false,u=false,r=false,d=false;
        if(Up.size()>0 &&  Up.front().first <= i){

            if(Left.size() == 0 || Left.front().first > i){
                Output.push_back(pair<long,long>(Up.front().second, i));
                u=true;
            } else ++f;
        }
        if(Down.size()>0 &&  Down.front().first <= i){
            if (Right.size() == 0 || Right.front().first > i){
                Output.push_back(pair<long,long>(Down.front().second, i));
                d=true;
            } else f++;
        }
        if(Left.size()>0 &&  Left.front().first <= i){
            if (Down.size() == 0 || Down.front().first > i) {
                Output.push_back(pair<long,long>(Left.front().second, i));
                l=true;
            } else ++f;
        }
        if(Right.size()>0 &&  Right.front().first <= i){
            if (Up.size() == 0 || Up.front().first > i) {
                 Output.push_back(pair<long,long>(Right.front().second, i));
                r=true;
            } else f++;
        }
        if (u) Up.pop();
        if (l) Left.pop();
        if (r) Right.pop();
        if (d) Down.pop();
        if(f== 4){
            for(long i = 0; i<Left.size(); ++i){
                Output.push_back(pair<long,long>(Left.front().second, -1));
                Left.pop();
            }
            for(long i = 0; i<Right.size(); ++i){
                Output.push_back(pair<long,long>(Right.front().second, -1));
                Right.pop();
            }
            for(long i = 0; i<Up.size(); ++i){
                Output.push_back(pair<long,long>(Up.front().second, -1));
                Up.pop();
            }
            for(long i = 0; i<Down.size(); ++i){
                Output.push_back(pair<long,long>(Down.front().second, -1));
                Down.pop();
            }
            break;
        }
        if (Up.size()+Down.size()+Right.size()+Left.size()==0) break;
    }

    sort(Output.begin(), Output.end(), [](pair<long,long> a, pair<long,long> b) {
        return b.first > a.first;
    });

    for(auto a:Output){
        cout<<a.second<<endl;
    }


    return 0;
}
