#include <iostream>
#include<vector>

using namespace std;

struct edge
{
	int s;
	int f;
};

int const MAXN = 1e5 + 5;
int n, m, used[MAXN], used2[MAXN], top[MAXN], used3[MAXN];
bool flag = 1;
edge edges[MAXN];
vector<int> g[MAXN];
vector<int> res;

void read_data()
{
	cin >> n >> m;
	for (int i = 0; i < m; i++)
	{
		int s, f;
		cin >> s >> f;
		g[f - 1].push_back(s - 1);
		edges[i].s = s - 1;
		edges[i].f = f - 1;
	}
}

int find_root()
{
	for (int i = 0; i < n; i++)
		used2[edges[i].s] = 1;
	int cnt = 0, root = 0;
	for (int i = 0; i < n; i++)
	{
		cnt += used2[i];
		if (!used2[i])
		    root = i;
	}
	if (cnt != n - 1)
		flag = false;
	return root;
}

void top_sort(int v)
{
	used[v] = 1;
	for (int i = 0; i < g[v].size(); i++)
	{
		if (!used[g[v][i]])
			top_sort(g[v][i]);
	}
	res.push_back(v);
}

int main()
{
	read_data();
	if (m < n - 1)
		flag = false;
	else
	{
		int root = find_root();
		if (flag)  
		    top_sort(root);
	}
	for (int i = 0; i < n; i++)
		if (!used[i])
			flag = false;
	for (int i = 0; i < res.size(); i++)
		top[res[i]] = i;
	int cnt = 0;
	for (int i = 0; i < m; i++)
	{
		if (top[edges[i].s] - top[edges[i].f] == -1)
			cnt++;
	}
	if (cnt != n - 1)
		flag = false;
	if (!flag)
		printf("-1");
	else
	{
		int ans = 0;
		for (int i = 0; i < m; i++)
		{
			if (top[edges[i].s] - top[edges[i].f] == -1)
				ans = i;
		}
		cout << ans + 1;
	}
	return 0;
}

