def sp(s):
    res = [''] * len(s)
    for i in range(len(s)):
        res[i] = s[i]
    return res


n, m, l = map(int, input().split())
field = [sp(input().strip()) for _ in range(n)]
pos = input().strip()
pos += pos[0]
GO = ((0, 1, "D"), (0, -1, "U"), (1, 0, "R"), (-1, 0, "L"))


def in_field(x, y):
    return 0 <= x < m and 0 <= y < n


def dfs(xn, yn, x, y, ind=1, path=None):
    if path is None:
        path = []
    if ind == len(pos):
        print("YES")
        print(len(path))
        print(xn + 1, yn + 1)
        print(*path, sep="")
        exit()
    for i in GO:
        x1 = x + i[0]
        y1 = y + i[1]
        if in_field(x1, y1) and field[y1][x1] == pos[ind]:
            path.append(i[2])
            dfs(xn, yn, x1, y1, ind + 1, path)
            path.pop()


for i in range(m):
    for j in range(n):
        if field[j][i] == pos[0]:
            dfs(i, j, i, j)
print("NO")
